#!/bin/sh

# Start the daemon
./test_multiple_tools_daemon &
DAEMON_PID=$!
echo daemon started with pid $DAEMON_PID

# Now try to see if we the tool can run and exit with no errors
./test_multiple_tools_tool
RETVAL=$?

echo Killing daemon with pid $DAEMON_PID
kill -9 $DAEMON_PID

if [ $RETVAL = 0 ]; then
    # The tool was able to run and exit with no errors
    touch test_multiple_tools
else
    rm test_multiple_tools
fi

exit $RETVAL
