#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"




void functionA()
{
  printf("functionA_v2 entered\n");
  HCU_MANUAL_UPDATE_POINT();
  printf("functionA_v2 exited\n");
}



void signal_handler(int s)
{
  printf("signal_handler_v1 executed\n");
  functionA();
}



int main()
{
  if (signal(SIGUSR1, signal_handler) == SIG_ERR) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
