#include "hcu_headers.h"



#include "test_sort_bubble_to_heap_unsortedNumbers.c"



void printNumbers(int numbers[], int array_size)
{
  int counter = 0;

  printf("The sorted numbers are:\n");
  while (counter < array_size) {
    printf("%ld\n", numbers[counter]);
    counter++;
  }
}



void heapify(int *heap, int start, int end)
{
    int last = ((end + 1) >> 1);
    while (start < last) {
           int lson = (start << 1) + 1;
           int rson = lson+1;
           int largest;

           if (rson <= end) {
                  if (heap[lson] < heap[rson])
                    largest = rson;
                  else
                    largest = lson;
           }
           else largest = lson;

           if (heap[largest] > heap[start]) {
                  int temp = heap[start];
                  heap[start] = heap[largest];
                  heap[largest] = temp;
                  start = largest;
           }
           else break;
    }
}


void buildheap(int *heap, int n)
{
    int i;
    for(i= n/2;i>=0;i--)
         heapify(heap,i,n);
}

void heapSort(int *numbers,int array_size)
{
    int i;

    printf("Running heapSort from the beginning with array_size %ld\n", array_size);

    buildheap(numbers,array_size - 1);
    for(i = array_size-1;i>0;i--) {
           int temp = numbers[0];
           numbers[0] = numbers[i];
           numbers[i] = temp;
           heapify(numbers,0,i-1);
    }
}


int main(void)
{
  int array_size  = unsortedNumbersSize;

  heapSort(unsortedNumbers, array_size);
  printNumbers(unsortedNumbers, array_size);

  return 0;
}
