struct my_type_s {
  int a;
  char c;
  float f;
};

typedef struct {
  struct my_type_s s;
  long value;
} my_other_type_t ;

union a_union_u {
  int a;
  long b;
};

struct my_type_s othervar1;
struct my_type_s othervar2;
extern int somevar1;
extern int somevar2;
extern int somevar3;

int main()
{
  int a;
  char c;
  float f;
  struct my_type_s s;
  my_other_type_t other;
  union a_union_u u;

  a = 4;
  c = 'c';
  f = 4.5;

  s.a = a;
  s.c = c;
  s.f = f;

  printf("s.a = %d\n", s.a);
  printf("s.c = %c\n", s.c);
  printf("s.f = %.2f\n", s.f);

  memcpy(&other.s, &s, sizeof(struct my_type_s));
  printf("other.s.f = %.2f\n", other.s.f);

  u.a = 9;
  printf("u.a = %d\n", u.a);

  return 0;
}
