#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_signal_handler_signal_v1.c_v1_to_v2.hcupatch.so.2",2);



void signal_handler(int s) __attribute__((__HCU_ATTRIBUTE_SIGNAL_HANDLER__, __HCU_ATTRIBUTE_NON_UPDATEABLE__))
{
  printf("signal_handler_v1 executed\n");
}



int main()
{
  if (signal(SIGUSR1, signal_handler) == SIG_ERR) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
