#include <pthread.h>
#include "hcu_headers.h"



__inline extern  __attribute__((__nothrow__)) unsigned long long gnu_dev_makedev(unsigned int __major ,
                                                                                 unsigned int __minor )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_minor(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_major(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;



#define DEBUG 0
#if (DEBUG == 1)
#define dprintf(format, args...) printf(format, ##args)
#else
#define dprintf(format, args...) do {} while (0)
#endif

extern pthread_mutex_t lock;

void exit_on_iterations(long iteration_counter, long max) HCU_NON_LIBRARY_FUNCTION;

void *thread_body(void *arg) HCU_NEW_VERSION;
void *thread_body(void *arg)
{
  long local_variable = 55555;
  long counter = 0;
  pthread_t thread_id;

  thread_id = pthread_self();
  while (1) {
    pthread_mutex_lock(&lock);
    counter++;
    exit_on_iterations(counter, 3);
    dprintf("HCU Thread_v2 %d using(%ld,%ld)...\n", thread_id, counter, local_variable);
    pthread_mutex_unlock(&lock);
    /* Sleep 0.1 seconds */
    usleep(100000);
    sched_yield();
  }
}



int HCU_update_description_function(void) HCU_NON_UPDATEABLE;
int HCU_update_description_function(void)
{
  hcu_set_update_description("thread_body_entry","thread_body_entry");
  printf("HCU_update_description_function_v2 executed\n");

  return 0;
}



extern void (*hcu_indirection_pointer__thread_body)(void *arg) HCU_NEW_VERSION ;
int HCU_function_updates_function(void) HCU_NON_UPDATEABLE;
int HCU_function_updates_function(void)
{
  hcu_indirection_pointer__thread_body = &thread_body;
  printf("HCU_function_updates_function_v2 executed\n");

  return 0;
}



int HCU_datatype_transformations_function(void) HCU_NON_UPDATEABLE;
int HCU_datatype_transformations_function(void)
{
  printf("HCU_datatype_transformations_function_v2 executed\n");

  return 0;
}
