#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_signal_handler_sigaction_sigdfl_v1.c_v1_to_v2.hcupatch.so.2",2);

int main()
{
  struct sigaction sigact;

  memset(&sigact, 0, sizeof(sigact));
  sigact.sa_handler = SIG_DFL;

  if (sigaction(SIGUSR1, &sigact, NULL) == -1) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
