#!/usr/bin/perl -w

#
# This script is used to generate a C file containing a definition of
# an array of unsorted integer numbers.
#

use strict;
use Data::Dumper;


main (@ARGV);
exit 0;

sub usage {
    print "Usage: $0 <size>\n";
}

sub main {
    my ($size) = ( @_ );
    my $output = "";

    if ( ! defined ( $size ) ) {
	usage();
	exit -1;
    }

    $output = "int updateIterations = $size;\n" . $output;
    print $output;
}
