#!/usr/bin/perl -w

#
# This script is used to generate a C file containing a definition of
# an array of unsorted integer numbers.
#

use strict;
use Data::Dumper;


main (@ARGV);
exit 0;

sub usage {
    print "Usage: $0 <datatype> <size>\n";
}

sub main {
    my ( $datatype, $size) = ( @_ );
    my $counter = 0;
    my $output = "";

    if ( ! defined ( $datatype ) ) {
	usage();
	exit -1;
    }

    if ( ! defined ( $size ) ) {
	usage();
	exit -1;
    }

    $output .=  $datatype . ' unsortedNumbers[] = { ';
    while ($counter < $size) {
	if ($counter > 0) {
	    $output .= ", ";
	}
	$output .= int ( rand($size) );
	$counter++
    }
    $output .= " };\n";
    $output = "int unsortedNumbersSize = $counter;\n" . $output;
    print $output;
}
