#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>



#define SERVER_PORT 42166
#define SERVER_HOSTNAME "127.0.0.1"
#define SEND_SIZE 1024 * 1024


int main()
{
  int sockfd;
  struct hostent *he;
  struct sockaddr_in their_addr; // connector's address information 
  int number_of_bytes_received;
  char send_buf[SEND_SIZE];
  long numbytes_sent;


  /* 
   * Setup a socket
   */
  if ((he=gethostbyname(SERVER_HOSTNAME)) == NULL) {  // get the host info 
    perror("client: gethostbyname error\n");
  }

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("client: socket error");
  }

  their_addr.sin_family = AF_INET;    // host byte order 
  their_addr.sin_port = htons(SERVER_PORT);  // short, network byte order 
  their_addr.sin_addr = *((struct in_addr *)he->h_addr);
  memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct 

  if (connect(sockfd, (struct sockaddr *)&their_addr,
	      sizeof(struct sockaddr)) == -1) {
    perror("client: connecting to server failed");
    return;
  }

  if (numbytes_sent = send(sockfd, send_buf, SEND_SIZE, 0) == -1)
    perror("send error");

  printf("%d bytes were sent\n", numbytes_sent);

  close(sockfd);
  
  return 0;
}
