#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_signal_handler_sigaction_pointer_parameter_v1.c_v1_to_v2.hcupatch.so.2",2);



void signal_handler(int s)
{
  printf("signal_handler_v1 executed\n");
}



void set_handler(struct sigaction *sigact, void (*p_handlefunc)(int))
{
  sigact->sa_handler = p_handlefunc;

  if (sigaction(SIGUSR1, sigact, NULL) == -1) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
}


int main()
{
  struct sigaction sigact;

  memset(&sigact, 0, sizeof(sigact));
  set_handler(&sigact, &signal_handler);
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
