#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_read_indefinitely_v1.c_v1_to_v2.hcupatch.so.2",2);


int filedes[2];


#define WRITE_MSG "something"
void *update_trigger(void *arg)
{
  int counter = 0;

  while(1) {
    counter++;
    if (counter == 2) {
      HCU_STATIC_REQUEST_UPDATE_IMMEDIATE();
    }
    sleep(1);
  }
}


void functionA()
{
  printf("This is functionA v1.\n");
}



int main()
{
  pthread_t update_trigger_id;
  char buf[1024];

  memset(&buf, 0, sizeof(buf));
  if (pipe(filedes) == -1) {
    perror("Failed to create pipe;");
    exit(-1);
  }

  pthread_create(&update_trigger_id,NULL,update_trigger,NULL);
  printf("Waiting indefinitely\n");
  read(filedes[0], &buf, 1);
  functionA();

  return 0;
}
