#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_signal_handler_signal_function_call_no_v1.c_v1_to_v2.hcupatch.so.2",2);



void functionA()
{
  printf("functionA_v1 entered\n");
  HCU_STATIC_REQUEST_UPDATE_IMMEDIATE();
  HCU_MANUAL_UPDATE_POINT();
  printf("functionA_v1 exited\n");
}



void signal_handler(int s)
{
  printf("signal_handler_v1 executed\n");
  functionA();
}



int main()
{
  if (signal(SIGUSR1, signal_handler) == SIG_ERR) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
