#include "hcu_headers.h"



__inline extern  __attribute__((__nothrow__)) unsigned long long gnu_dev_makedev(unsigned int __major ,
                                                                                 unsigned int __minor )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_minor(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;
__inline extern  __attribute__((__nothrow__)) unsigned int gnu_dev_major(unsigned long long __dev )  __attribute__((__HCU_ATTRIBUTE_NON_LIBRARY_FUNCTION__)) ;



extern int stop;

struct hcu_stack_local_functionA_v1_s
{
  int some_value;
  int retval;
  hcu_stack_trace_t *hcu_stack_trace_var;
  struct hcu_stack_frame_fields_s hcu_stack_frame_fields;
};

struct hcu_stack_local_functionA_v2_s
{
  int retval;
  int some_value;
  hcu_stack_trace_t *hcu_stack_trace_var;
  struct hcu_stack_frame_fields_s hcu_stack_frame_fields;
};


void HCU_stack_transformer__functionA(void *transform_stack_to, void *transform_stack_from, void *transform_params_to) HCU_NON_UPDATEABLE;
void HCU_stack_transformer__functionA(void *transform_stack_to, void *transform_stack_from, void *transform_params_to)
{
  struct hcu_stack_local_functionA_v1_s *stack_to;
  struct hcu_stack_local_functionA_v2_s *stack_from;

  stack_to = (struct hcu_stack_local_functionA_v1_s *) transform_stack_to;
  stack_from = (struct hcu_stack_local_functionA_v2_s *) transform_stack_from;

  stack_to->retval = stack_from->retval;
  stack_to->some_value = stack_from->some_value;
  stack_to->hcu_stack_trace_var = stack_from->hcu_stack_trace_var;
  hcu_copy_stack_frame_fields(&stack_to->hcu_stack_frame_fields,&stack_from->hcu_stack_frame_fields);
}



int functionA(void) HCU_NEW_VERSION;
int functionA(void)
{
  int retval = 0;
  int some_value = 100;

  printf("This is functionA v2\n");
  while (stop == 5)
  {
    stop = 4;
    /* We add this loop to force creation of a new basic block which
       will produce an HCU_try_to_update call */
  }

  retval = some_value + 2;

  return retval;
}



int HCU_update_description_function(void) HCU_NON_UPDATEABLE;
int HCU_update_description_function(void)
{
  hcu_set_update_description("main","main");
  printf("HCU_update_description_function_v2 executed\n");

  return 0;
}



int (*hcu_indirection_pointer__functionA)(void) HCU_NEW_VERSION;
int HCU_function_updates_function(void) HCU_NON_UPDATEABLE;
int HCU_function_updates_function(void)
{
  hcu_indirection_pointer__functionA = &functionA;
  printf("HCU_function_updates_function_v2 executed\n");

  return 0;
}



int HCU_datatype_transformations_function(void) HCU_NON_UPDATEABLE;
int HCU_datatype_transformations_function(void)
{
  printf("HCU_datatype_transformations_function_v2 executed\n");

  return 0;
}
