#include <stdio.h>
#include <signal.h>
#include "hcu_headers.h"
HCU_STATIC_UPDATE_FILE("./libtest_signal_handler_sigaction_struct_v1.c_v1_to_v2.hcupatch.so.2",2);

struct sometype_s {
  struct sigaction sigact;
  int some_other_field;
};


void signal_handler(int s)
{
  printf("signal_handler_v1 executed\n");
}



int main()
{
  struct sometype_s somevar;

  memset(&somevar, 0, sizeof(somevar));
  somevar.sigact.sa_handler = signal_handler;

  if (sigaction(SIGUSR1, &somevar.sigact, NULL) == -1) {
    perror("There was an error setting the signal handler:");
    exit(-1);
  }
  kill(getpid(), SIGUSR1);
  printf("Signal handler signal() test exiting\n");

  return 0;
}
